<script lang="ts">
import Vue from 'vue';

interface Question {
  question: string;
  answer: string;
}

interface Texts {
  show: string;
  hide: string;
}

export default Vue.extend({
  props: {
    header: {
      type: String,
      required: true,
    },
    texts: {
      type: Object as () => Texts,
      required: true,
    },
    questions: {
      type: Array<Question>,
      required: true,
    },
  },
  data() {
    return {
      showAll: null,
      questionOpened: new Array(this.questions.length).fill(false),
      data: {
        data_inbound_analytics: 'pricing-leap-target',
        background: false,
      },
    };
  },
  mounted() {
    this.showAll = false;
  },
  methods: {
    toggleVisibility(): void {
      this.showAll = !this.showAll;
      this.questionOpened = new Array(this.questions.length).fill(this.showAll);
    },
    toggleQuestion(questionIndex: number) {
      this.$set(
        this.questionOpened,
        questionIndex,
        !this.questionOpened[questionIndex],
      );
    },
  },
});
</script>

<template>
  <SlpContainer
    :data-aos="'fade-up'"
    :data-aos-duration="1200"
    :data-aos-offset="200"
  >
    <div class="faq">
      <div data-section class="faq__container">
        <div class="faq__wrapper">
          <div
            v-if="header || data.show_all_button"
            aria-live="polite"
            class="faq__group-header"
            :class="{ 'faq__group-header--has-header': header }"
          >
            <SlpTypography tag="h2" variant="heading2-bold">{{
              header
            }}</SlpTypography>
            <div />

            <button
              v-if="!showAll"
              type="button"
              class="action"
              :data-toggle-group="header"
              @click="toggleVisibility()"
            >
              <SlpTypography
                class="group-control"
                variant="body2"
                role="button"
                :aria-label="`Expand all ${header} items.`"
              >
                {{ texts && texts.show ? texts.show : 'Show All' }}
              </SlpTypography>
            </button>
            <button
              v-else
              type="button"
              tabindex="0"
              :aria-label="`Close all ${header} items.`"
              class="action"
              @click="toggleVisibility()"
            >
              <SlpTypography class="group-control" variant="body2">
                {{ texts && texts.hide ? texts.hide : 'Hide All' }}
              </SlpTypography>
            </button>
          </div>
          <div
            v-for="(item, questionIndex) in questions"
            :key="`question-${questionIndex}`"
          >
            <button
              :id="`${questionIndex}-button`"
              type="button"
              :aria-controls="`${questionIndex}-content`"
              class="faq__group-questions"
              :class="{
                'faq__group-questions--expanded': questionOpened[questionIndex],
              }"
              :aria-expanded="questionOpened[questionIndex]"
              :data-inbound-analytics="data.data_inbound_analytics"
              :data-toggle-group="header"
              :data-ga-toggle="
                questionOpened[questionIndex] ? 'collapse' : 'expand'
              "
              @click="toggleQuestion(questionIndex)"
            >
              <span :id="questionIndex" class="anchor-target"></span>
              <SlpTypography
                :ref="questionIndex"
                :data-anchor-index="`${questionIndex}`"
                tag="h4"
                variant="body1-bold"
                >{{ item.question }}</SlpTypography
              >
              <SlpIcon
                v-if="questionOpened[questionIndex]"
                class="faq__expand-icon"
                name="dash"
                variant="product"
                alt="Dash Icon"
              />
              <SlpIcon
                v-else
                class="faq__expand-icon"
                name="plus"
                variant="product"
                alt="Plus Icon"
              />
            </button>
            <div
              v-if="questionOpened[questionIndex]"
              :id="`${questionIndex}-content`"
              role="region"
              :aria-labelledby="`${questionIndex}-button`"
              :class="{
                'faq__content--expanded': questionOpened[questionIndex],
              }"
              class="faq__content"
            >
              <div class="faq__answer" v-html="$md.render(item.answer)" />
            </div>
          </div>
        </div>
      </div>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
* {
  color: white;
}

$visible-height: 70px;
.jump_button {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  height: 100%;
  width: 57px;
  background-color: $color-surface-900;
  color: $color-primary-200;
  border-radius: $border-radius-4;
  padding: $spacing-32 $spacing-8;
  margin-top: 25vh;
  text-align: center;
  &:hover {
    background-color: $color-surface-950;
  }
  .slp-icon {
    transform: rotate(90deg);
  }
  @media (max-width: $breakpoint-lg) {
    display: none;
  }
}

.slp-faq {
  display: flex;
  justify-content: space-between;
  padding: $spacing-96 $spacing-16 !important;
  flex-direction: column;
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-64 $spacing-16 !important;
  }
}
.anchor-target {
  bottom: 100%;
  display: block;
  height: 75px;
  position: absolute;
  visibility: hidden;
  width: 100%;
}

.faq {
  max-width: 100%;
  &__title {
    padding-right: $spacing-48;
    margin-bottom: $spacing-32;
    text-align: left;
    position: relative;

    @media (max-width: $breakpoint-md) {
      margin: 0;
      padding: 0;
    }
    &__active {
      font-size: 1.3rem;
      margin-bottom: 1rem;
    }
    &__sticky {
      top: 200px;
      position: sticky;
      display: inline-block;
    }
    &__normal {
      position: relative;
      display: inline-block;
    }
  }

  .view-more {
    margin-top: $spacing-32;
    text-align: center;
    cursor: pointer;
    border: none;
    width: 100%;
  }

  .group-control {
    color: $color-text-link-100;
    cursor: pointer;
    text-decoration: underline;
    font-weight: 600;
    white-space: nowrap;
  }

  &--double-column {
    @media (min-width: 1024px) {
      column-count: 2;
    }
  }

  &__container {
    margin: 2rem 0;
  }

  &__wrapper {
    display: inline-block;
    width: 100%;

    .action {
      border: none;
    }
  }

  &__group-header,
  &__group-questions {
    padding: $spacing-16 0;
    display: flex;
    background: transparent;
    justify-content: space-between;
    border-bottom: 1px solid $color-surface-600;
    align-items: center;
    position: relative;
    min-height: $visible-height;
    color: $color-primary-200;

    &--expanded {
      border-bottom: none;
    }

    img {
      min-width: 1rem;
    }
  }
  &__group-header {
    &--has-header {
      border-bottom: 1px solid $color-surface-500;
    }
  }
  &__group-questions {
    cursor: pointer;
    width: 100%;
    text-align: left;
    font-size: inherit;
    font-weight: inherit;
    border-top: none;
    border-left: none;
    border-right: none;
  }

  &__header {
    font-size: 24px;
    line-height: 30px;
    @media (min-width: $breakpoint-lg) {
      font-size: 32px;
      line-height: 36px;
    }
  }

  &__content {
    padding: 1rem 0;
    display: flex;
    justify-content: space-between;
    align-items: center;
    @media (min-width: $breakpoint-lg) {
      padding: 0 0 16px;
    }
    &--expanded {
      border-bottom: 1px solid $color-surface-400;
    }
  }

  .view-more-icon {
    margin-left: $spacing-16;
  }

  &__expand-icon {
    object-fit: scale-down;
    margin-left: $spacing-16;
  }

  .anchor-icon {
    cursor: pointer;
    margin-left: $spacing-16;
  }

  &__question {
    font-size: 19px;
    line-height: 24px;
    margin-bottom: 8px;

    @media (min-width: $breakpoint-lg) {
      font-size: 23px;
      line-height: 28px;
    }
  }

  &__answer {
    &:deep {
      ul {
        list-style-type: disc;
        list-style-position: inside;
        padding-left: 1.3em;
        text-indent: -1.3em;
      }
      li {
        margin-bottom: $spacing-8;
      }
      p:not(:last-of-type),
      ul:not(:last-of-type),
      ol:not(:last-of-type) {
        margin-bottom: $spacing-16;
      }

      p {
        color: $color-surface-400;
      }
      a {
        color: $color-accent-400;
      }
    }
  }
}
</style>
